#ifndef __SOTERRAIN_H
#define __SOTERRAIN_H

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoIndexedFaceSet.h>

#include <iostream.h>
#include "DEM.h"
#include "VRML.h"


class SoTerrain : public SoSeparator
{
public:
  int size; //temporarly
  int dim;
  float meshThresh;
  ELEV **demData;
  
  SoTerrain(char *name, float aMeshThresh): SoSeparator()
  {
    meshThresh = aMeshThresh;

    char ext[4];
    int len = strlen(name);
    ext[0] = name[len-3];
    ext[1] = name[len-2];
    ext[2] = name[len-1];
    ext[3] = 0;
    DEM *df;
    if (!strcmp(ext, "dwv") || !strcmp(ext, "cps")) 
      df = new URLCompressedDEM((char*)name);
    if (!strcmp(ext, "dem")) 
      df = new URLDEM((char*)name);
    df->read();

    demData = df->data;
    dim = df->dim;

  };

  SoTerrain(ELEV **aDEMData, float aMeshThresh, int aDim): SoSeparator()
  {

    dim = aDim;
    meshThresh = aMeshThresh;

    NewMatrix(demData, aDim, aDim, ELEV);
    
    for(int i=0; i<aDim; i++)
      for(int j=0; j<aDim; j++)
	demData[i][j] = aDEMData[i][j];

  };

  SoTerrain(int aSize): SoSeparator(), size(aSize)
  {
    tmp_build();
  };

  void tmp_build();

  void build();
  void buildCoordinates();
  void buildFaceSet();

protected:
  ~SoTerrain();
};

#endif
